Index: guard.py
===================================================================
RCS file: /cvs/Quotient/nevow/guard.py,v
retrieving revision 1.13
diff -u -r1.13 guard.py
--- guard.py	27 Jan 2004 16:41:22 -0000	1.13
+++ guard.py	3 Feb 2004 21:50:32 -0000
@@ -135,8 +135,7 @@
         self.checkExpired()
 
 
-def urlToChild(request, *ar, **kw):
-    orig = request.prePathURL()
+def urlToChild(request, orig, *ar, **kw):
     c = '/'.join(ar)
     if orig[-1] == '/':
         # this SHOULD only happen in the case where the URL is just the hostname
@@ -187,10 +186,13 @@
     def locateChild(self, request, segments):
         path = segments[0]
         cookie = request.getCookie(self.cookieKey)
+        prepath = request.prePathURL()
+        request.setupSession = lambda : self.createSession(request, prepath, segments)
+        
         if path.startswith(SESSION_KEY):
             key = path[len(SESSION_KEY):]
             if key not in self.sessions:
-                return Redirect(urlToChild(request, *segments[1:], **{'__start_session__':1})), ()
+                return Redirect(urlToChild(request, prepath, *segments[1:], **{'__start_session__':1})), ()
             self.sessions[key].setLifetime(self.sessionLifetime)
             if cookie == key:
                 # /sessionized-url/${SESSION_KEY}aef9c34aecc3d9148/foo
@@ -198,7 +200,7 @@
                 #                  we are this getChild
                 # with a matching cookie
                 self.sessions[key].sessionJustStarted = True
-                return Redirect(urlToChild(request, *segments[1:], **{'__session_just_started__':1})), ()
+                return Redirect(urlToChild(request, prepath, *segments[1:], **{'__session_just_started__':1})), ()
             else:
                 # We attempted to negotiate the session but failed (the user
                 # probably has cookies disabled): now we're going to return the
@@ -239,18 +241,24 @@
                         afterLogin).addErrback(errorLogin)
 
             # no, really, without a session
-            newCookie = _sessionCookie()
-            request.addCookie(self.cookieKey, newCookie, path="/")
-            sz = self.sessions[newCookie] = GuardSession(self, newCookie)
-            sz.args = request.args
-            sz.content = request.content
-            sz.method = request.method
-            sz.received_headers = request.received_headers
-            sz.checkExpired()
             ## Redirect to the URL with the session key in it, plus the segments of the url
-            rd = Redirect(urlToChild(request, SESSION_KEY+newCookie, *segments))
+            rd = self.createSession(request, prepath, segments)
             return rd, ()
-
+    
+    def createSession(self, request, prepath, segments):
+        """Create a new session for this request, and redirect back to the path
+        given by segments."""
+        
+        newCookie = _sessionCookie()
+        request.addCookie(self.cookieKey, newCookie, path="/")
+        sz = self.sessions[newCookie] = GuardSession(self, newCookie)
+        sz.args = request.args
+        sz.content = request.content
+        sz.method = request.method
+        sz.received_headers = request.received_headers
+        sz.checkExpired()
+        return Redirect(urlToChild(request, prepath, SESSION_KEY+newCookie, *segments))
+        
     def checkLogin(self, request, segments):
         path = segments[0]
         s = request.getSession()
